<?php
/**
 * Bicycle Libraries
 *
 * Set of libraries wich can help you
 *
 * @package   Bicycle Libraries
 * @author    Konstantin.Myakshin
 * @copyright Copyright (c) 2009-2010, Brouzie, Inc.
 * @license   LGPL
 * @link      http://brouzie.com/projects/bicycle-libraries/
 * @link      http://code.google.com/p/bicycle-libraries/
 * @filesource
 */

define('BL_TIME_START', microtime(true));

if (version_compare(PHP_VERSION, '5.3.0') === -1) {
	// < 5.3.0
	ini_set('zend.ze1_compatibility_mode', 0);
}

// go to dir where index.php located
chdir(dirname(__FILE__) . '/..');
$dirs = include 'config/common/dirs.php';
define('BL_CORE_DIR', $dirs['core']);

include_once 'config/common/main.php';
include_once BL_CORE_DIR . 'functions.php';
include_once BL_CORE_DIR . 'Loader.php';
$loader = BL_Loader::autoloadRegister($dirs)
	->registerVendor('Zend')
	->registerVendor('Twig')
	->registerVendor('ImageTransform');

$context = BL_Context::instance();
$context->injectLoader($loader);

if (BL_DEBUG_ENABLED) {
	set_error_handler(array('BL_ErrorsHanding', 'customErrorHandler'), error_reporting());
	set_exception_handler(array('BL_ErrorsHanding', 'uncaughtExceptionHandler'));
	register_shutdown_function(array('BL_ErrorsHanding', 'shutdownHandler'));
	ini_set('display_errors', 'Off');
}
