<?php
/**
 * Bicycle Libraries
 *
 * Set of libraries wich can help you
 *
 * @package   Bicycle Libraries
 * @author    Konstantin.Myakshin
 * @copyright Copyright (c) 2009-2010, Brouzie, Inc.
 * @license   LGPL
 * @link      http://brouzie.com/projects/bicycle-libraries/
 * @link      http://code.google.com/p/bicycle-libraries/
 * @filesource
 */

class BL_Deploy_Vcs_Adapter_Mercurial extends BL_Deploy_Vcs_AdapterAbstract
{
	protected $command = 'hg';

	public function getChanges($revFrom, $revTo = NULL, $all = false)
	{
		$all = $all ? '--all' : '';
		$command = $revTo ?
			sprintf('%s status --rev %s:%s %s', $this->command, $revFrom, $revTo, $all) :
			sprintf('%s status --rev %s %s',    $this->command, $revFrom, $all);
		
		$output = array();
		$status = exec($command, $output);
		$filesToRemove = $filesToUpload = array();

		foreach ($output as $file) {
			list($action, $file) = explode(' ', $file, 2);

			switch ($action) {
				case 'R':
					$filesToRemove[] = $this->fixPath($file);
					break;
				//TODO: another actions (copy/move)?
				case 'A':
				case 'M':
				case 'C':
					$filesToUpload[] = $this->fixPath($file);
					break;
			}
		}

		return array('upload' => $filesToUpload, 'remove' => $filesToRemove);
	}

	public function getRevision()
	{
		$command = sprintf('%s log -l 1 --template "{rev}"', $this->command);
		$output = array();
		$status = exec($command, $output);
		return $output[0];
	}

	public function export($path, $rev = NULL)
	{
		$rev || $rev = $this->getRevision();

		$command = sprintf('%s archive -r %d %s', $this->command, $rev, $path);
		//$output = array();
		$status = exec($command, $output);
		//return $output[0];
	}
}
