<?php
/**
 * Bicycle Libraries
 *
 * Set of libraries wich can help you
 *
 * @package   Bicycle Libraries
 * @author    Konstantin.Myakshin
 * @copyright Copyright (c) 2009-2010, Brouzie, Inc.
 * @license   LGPL
 * @link      http://brouzie.com/projects/bicycle-libraries/
 * @link      http://code.google.com/p/bicycle-libraries/
 * @filesource
 */

class BL_Request_Storage extends BL_Request implements ArrayAccess
{
	/**
	 *
	 * @var BL_Request
	 */
	protected $request;
	
	protected $type;
	
	protected function __construct(BL_Request $request, $type)
	{
		$this->request = $request;
		$this->type = $type;
	}
	
	public function __get($key)
	{
		return $this->request->getVariable($this->type, $key);
	}
	
	public function __set($key, $value)
	{
		$this->request->set($key, $value, $this->type);
	}

	public function offsetExists($offset)
	{
		return $this->request->has($offset, $this->type);
	}

	public function offsetGet($offset)
	{
		return $this->request->getVariable($this->type, $offset);
	}

	public function offsetSet($offset, $value)
	{
		$this->request->set($key, $value, $this->type);
	}

	public function offsetUnset($offset)
	{
		$this->request->set($key, self::DEFAULT_VALUE, $this->type);
	}
}
