<?php
/**
 * Bicycle Libraries
 *
 * Set of libraries wich can help you
 *
 * @package   Bicycle Libraries
 * @author    Konstantin.Myakshin
 * @copyright Copyright (c) 2009-2010, Brouzie, Inc.
 * @license   LGPL
 * @link      http://brouzie.com/projects/bicycle-libraries/
 * @link      http://code.google.com/p/bicycle-libraries/
 * @filesource
 */

class BL_Request_StorageCookie extends BL_Request implements ArrayAccess
{
	/**
	 *
	 * @var BL_Request
	 */
	protected $request;
	
	protected function __construct(BL_Request $request)
	{
		$this->request = $request;
	}
	
	public function __get($key)
	{
		return $this->request->cookies($key);
	}
	
	public function __set($key, $value)
	{
		throw new BL_Exception('Use response for setting cookies');
	}

	public function offsetExists($offset)
	{
		return $this->request->has($offset, self::COOKIES);
	}

	public function offsetGet($offset)
	{
		return $this->request->cookies($offset);
	}

	public function offsetSet($offset, $value)
	{
		throw new BL_Exception('Use response for setting cookies');
	}

	public function offsetUnset($offset)
	{
		throw new BL_Exception('Use response for remove cookies');
	}
}
