<?php
/**
 * Bicycle Libraries
 *
 * Set of libraries wich can help you
 *
 * @package   Bicycle Libraries
 * @author    Konstantin.Myakshin
 * @copyright Copyright (c) 2009-2010, Brouzie, Inc.
 * @license   LGPL
 * @link      http://brouzie.com/projects/bicycle-libraries/
 * @link      http://code.google.com/p/bicycle-libraries/
 * @filesource
 */

class BL_Request_StorageFiles extends BL_Request implements ArrayAccess
{
	/**
	 *
	 * @var BL_Request
	 */
	protected $request;
	
	protected function __construct(BL_Request $request)
	{
		$this->request = $request;
	}
	
	public function __get($key)
	{
		return $this->request->getVariable(self::FILES, $key);
	}
	
	public function __set($key, $value)
	{
		throw new BL_Exception('You cann\'t set FILES');
	}

	public function offsetExists($offset)
	{
		return $this->request->has($offset, self::FILES);
	}
	
	public function offsetGet($offset)
	{
		return $this->request->getVariable(self::FILES, $offset);
	}
	
	public function offsetSet($offset, $value)
	{
		throw new BL_Exception('You cann\'t set FILES');
	}
	
	public function offsetUnset($offset)
	{
		throw new BL_Exception('You cann\'t unset FILES');
	}
}
