<?php
/**
 * Bicycle Libraries
 *
 * Set of libraries wich can help you
 *
 * @package   Bicycle Libraries
 * @author    Konstantin.Myakshin
 * @copyright Copyright (c) 2009-2010, Brouzie, Inc.
 * @license   LGPL
 * @link      http://brouzie.com/projects/bicycle-libraries/
 * @link      http://code.google.com/p/bicycle-libraries/
 * @filesource
 */

class BL_Router_Database implements BL_Router_Interface
{
	public function parse(&$url)
	{
		$parts = explode('/', $url);
		$items = array();
		foreach ($parts as $key => $part) {
			$items[] = $key ? $items[$key - 1] . '/' . $part : $part;
		}

		$data = BL_Context::instance()->db()->fetch('
			SELECT
				url, module, data, params,
				SUBSTRING(?s FROM LENGTH(url) + 1) AS pvalues
			FROM :rewrites
			WHERE url IN (?s@)
			ORDER BY LENGTH(url) DESC', $url, $items);

		if (!$data || ($data['pvalues'] && !$data['params'])) // no any matches or params not needed
			return false;

		$return = array('m' => $data['module']);
		$return = array_merge($return, json_decode($data['data'], true));

		if (!$data['params'])
			return $return;

		$values = $data['pvalues'] ? explode('/', trim($data['pvalues'], '/')) : array();

		foreach (explode('/', $data['params']) as $key => $param) {
			$return[$param] = isset($values[$key]) ? $values[$key] : false;
			//TODO: if count of values > count of params - false
		}

		return $return;
	}
}
