<?php
/**
 * Bicycle Libraries
 *
 * Set of libraries wich can help you
 *
 * @package   Bicycle Libraries
 * @author    Konstantin.Myakshin
 * @copyright Copyright (c) 2009-2010, Brouzie, Inc.
 * @license   LGPL
 * @link      http://brouzie.com/projects/bicycle-libraries/
 * @link      http://code.google.com/p/bicycle-libraries/
 * @filesource
 */

class BL_Router_SemiDynamic implements BL_Router_Interface
{
	protected $routers = array();
	
	public function __construct(array $routers = array())
	{
		$this->routers = $routers ? $routers : BL_Settings::get('routers', 'semiDynamic');
	}
	
	public function parse(&$url)
	{
		$matches = array();
		foreach ($this->routers as $router => $data) {
			$pattern = '#^' . patternToRegexp($router) . '$#';
			
			if (preg_match($pattern, $url, $matches)) {
				
				$params = isset($data['params']) ? $data['params'] : array();
				unset($data['params']);
				array_shift($matches);
				if (count($matches) != count($params))
					throw new BL_Exception('Mismatching of parametrs count');

				$params && $params = array_combine($params, $matches);
				return array_merge($data, $params);
			}
		}
	}
}
