<?php

class BL_Session_StorageAdapter_File implements BL_Session_StorageAdapterInterface
{
	protected $options = array(
		'dir' => 'var/session/',
		'ext' => 'session'
	);

	public function __construct(array $options = array())
	{
		$this->options = array_merge($this->options, $options);
	}

	public function destroy($id)
	{
		file_exists($file = $this->getFile($id)) && unlink($file);
	}

	protected function getFile($id)
	{
		return $this->options['dir'] . $id . '.' . $this->options['ext'];
	}

	protected function isExpiries($file, $ttl)
	{
		return filemtime($file) + $ttl < time() && 0 !== $ttl;
	}

	protected function getId($file)
	{
		return substr($file, strlen($this->options['dir']), - strlen($this->options['ext']) - 1);
	}

	public function read($id, $ttl = 0)
	{
		return file_exists($file = $this->getFile($id)) && !$this->isExpiries($file, $ttl) ? file_get_contents($file) : '';
	}

	public function write($id, $data)
	{
		file_put_contents($this->getFile($id), $data);
	}

	public function getExpiried($ttl)
	{
		$expiried = array();
		foreach (glob($this->getFile('*')) as $file) {
			$this->isExpiries($file, $ttl) && $expiried[] = $this->getId($file);
		}
		return $expiried;
	}
}
