<?php
/**
 * Bicycle Libraries
 *
 * Set of libraries wich can help you
 *
 * @package   Bicycle Libraries
 * @author    Konstantin.Myakshin
 * @copyright Copyright (c) 2009-2010, Brouzie, Inc.
 * @license   LGPL
 * @link      http://brouzie.com/projects/bicycle-libraries/
 * @link      http://code.google.com/p/bicycle-libraries/
 * @filesource
 */

/**
 * Settings class
 *
 * @package Bicycle Libraries
 * @author  Konstantin.Myakshin
 * @link    http://brouzie.com/projects/bicycle-libraries/user-guide/settings.html
 */
abstract class BL_Settings
{
	private static $pathes = array();
	
	private static $settings = array();
	
	public static function setPathes($token, $path = '', $type = 'default')
	{
		if (is_array($token)) {
			$tokens = $token;
			foreach ($tokens as $token => $tokenValue) {
				if (is_array($tokenValue)) {
					foreach ($tokenValue as $type => $path) {
						self::$pathes[$token][$type] = $path;
					}
				} else {
					self::$pathes[$token]['default'] = $tokenValue;
				}
			}
		} else {
			self::$pathes[$token][$type] = $path;
		}
	}
	
	private static function load($token, $type)
	{
		self::$settings[$token][$type] = array();
		if (isset(self::$pathes[$token][$type])) {
			if (file_exists(self::$pathes[$token][$type]))
				self::$settings[$token][$type] = include self::$pathes[$token][$type];
		}
		
		return self::$settings[$token][$type];
	}
	
	public static function get($token, $type = 'default')
	{
		return (isset(self::$settings[$token][$type])) ?
			self::$settings[$token][$type] : self::load($token, $type);
	}

	public static function getMerged(array $default, $token, $type = 'default')
	{
		return array_merge_recursive_distinct($default, self::get($token, $type));
	}
}
