<?php
/**
 * Bicycle Libraries
 *
 * Set of libraries wich can help you
 *
 * @package   Bicycle Libraries
 * @author    Konstantin.Myakshin
 * @copyright Copyright (c) 2009-2010, Brouzie, Inc.
 * @license   LGPL
 * @link      http://brouzie.com/projects/bicycle-libraries/
 * @link      http://code.google.com/p/bicycle-libraries/
 * @filesource
 */

class BL_Template_Node_Resource extends Twig_Node implements Twig_NodeListInterface
{
  protected $expr;
	protected $type;
	protected $rev;

  public function __construct(Twig_Node_Expression $expr, $lineno, $type, $rev = NULL, $tag = null)
  {
    parent::__construct($lineno, $tag);
		
    $this->expr = $expr;
		$this->type = $type;
		$this->rev  = $rev;
  }

  public function __toString()
  {
    return get_class($this) . '(' . $this->expr . ')';
  }
	// WTF?
  public function getNodes()
  {
		return array();
  }
	// WTF?
  public function setNodes(array $nodes) {}

	public function compile($compiler)
	{
		$compiler->addDebugInfo($this);
//		var_dump($this->expr);
//		exit;
		
		if ('js' == $this->type) {
			$compiler
				->write('BL_Page::instance()->addJavascript(')
				->subcompile($this->expr);
		} elseif ('css' == $this->type) {
			$compiler
				->write('BL_Page::instance()->addStylesheet(')
				->subcompile($this->expr);
		} else {
			throw new BL_Exception('Unknown resource');
		}
		$compiler->raw(");\n");
	}
}
