<?php
/**
 * Bicycle Libraries
 *
 * Set of libraries wich can help you
 *
 * @package   Bicycle Libraries
 * @author    Konstantin.Myakshin
 * @copyright Copyright (c) 2009-2010, Brouzie, Inc.
 * @license   LGPL
 * @link      http://brouzie.com/projects/bicycle-libraries/
 * @link      http://code.google.com/p/bicycle-libraries/
 * @filesource
 */

class BL_Template_Node_Widget extends Twig_Node
{
	protected $expr;
	protected $widget;

	public function __construct($widget, Twig_Node_Expression $expr = null, $lineno, $tag = null)
	{
		parent::__construct($lineno, $tag);

		$this->expr = $expr;
		$this->widget = $widget;
  }

	public function compile($compiler)
	{
		//var_dump($this->widget, $this->expr);
		//exit;
		$compiler->addDebugInfo($this);

		$compiler
			->write("echo BL_Loader::instance()->execWidget(")
			->string($this->widget);

		if ($this->expr) {
			$compiler
				->write(", ")
				->subcompile($this->expr);
		}

		$compiler
			->write(");\n");
	}
}
