<?php
/**
 * Bicycle Libraries
 *
 * Set of libraries wich can help you
 *
 * @package   Bicycle Libraries
 * @author    Konstantin.Myakshin
 * @copyright Copyright (c) 2009-2010, Brouzie, Inc.
 * @license   LGPL
 * @link      http://brouzie.com/projects/bicycle-libraries/
 * @link      http://code.google.com/p/bicycle-libraries/
 * @filesource
 */

class BL_Template_TokenParser_Resource extends Twig_TokenParser
{
	public function parse(Twig_Token $token)
	{
		$type = NULL;
		if ($this->parser->getStream()->test('js')) {
			$type = 'js';
		} elseif ($this->parser->getStream()->test('css')) {
			$type = 'css';
		} else {
			throw new BL_Exception('Unknown resource');
		}

		$this->parser->getStream()->next();
		$expr = $this->parser->getExpressionParser()->parseExpression();
		$this->parser->getStream()->expect(Twig_Token::BLOCK_END_TYPE);

		return new BL_Template_Node_Resource($expr, $token->getLine(), $type, '', $this->getTag());
	}

	public function getTag()
	{
		return 'res';
	}
}
