<?php
/**
 * Bicycle Libraries
 *
 * Set of libraries wich can help you
 *
 * @package   Bicycle Libraries
 * @author    Konstantin.Myakshin
 * @copyright Copyright (c) 2009-2010, Brouzie, Inc.
 * @license   LGPL
 * @link      http://brouzie.com/projects/bicycle-libraries/
 * @link      http://code.google.com/p/bicycle-libraries/
 * @filesource
 */

class BL_Template_TokenParser_Widget extends Twig_TokenParser
{
	public function parse(Twig_Token $token)
	{
		$lineno = $token->getLine();

		$widgetName = NULL;
		$expr = NULL;

		$widgetName = $this->parser->getStream()->expect(Twig_Token::STRING_TYPE)->getValue();

		if (!$this->parser->getStream()->test(Twig_Token::BLOCK_END_TYPE)) {
			$expr = $this->parser->getExpressionParser()->parseExpression();
		}
		$this->parser->getStream()->expect(Twig_Token::BLOCK_END_TYPE);

		return new BL_Template_Node_Widget($widgetName, $expr, $lineno, $this->getTag());
	}

	public function getTag()
	{
		return 'widget';
	}
}
