<?php

class BL_TreeStructure
{
	protected static $instances = array();

	protected static $settings = array();

	public static function settings($name, array $options = array())
	{
		if (empty($options)) {
			if (empty(self::$settings[$name]))
				throw new BL_Exception('Settings problem');

			return self::$settings[$name];
		}
		empty(self::$settings[$name]) ? self::$settings[$name] = $options :
			self::$settings[$name] = array_merge_recursive_distinct(self::$settings[$name], $options);
	}

	public static function isDriverAvalible($driver)
	{
		return (class_exists($driver, true) || class_exists($driver = 'BL_TreeStructure_Driver_' . ucfirst($driver), true))
				&& in_array('BL_TreeStructure_DriverAbstract', class_parents($driver)) ? $driver : false;
	}

	/**
	 *
	 * @param string $name
	 * @return BL_TreeStructure_DriverInterface
	 */
	public static function factory($name, array $options = array())
	{
		if (isset(self::$instances[$name]))
			return self::$instances[$name];

		$options &&	self::settings($name, $options);

		$options = self::settings($name);
		if ($driver = self::isDriverAvalible($options['driver'])) {
			return self::$instances[$name] = new $driver($options);
		}
		throw new BL_Exception('Driver problem');
	}
}
