<?php

class BL_TreeStructure_Driver_RedundantAdjacencyList extends BL_TreeStructure_DriverAbstract
{
	protected $structure;
	public function __construct(array $options)
	{
		parent::__construct($options);
		if (empty($options['structure']))
			throw new BL_Exception('Structure table problem');

		$this->structure = $options['structure'];
	}

	public function addNode($data, $parentId = 0, $sorder = NULL)
	{
		//TODO: sorder
		$t = $this->table;

		$data['pid'] = $parentId;
		$this->db->multiQuery("
			SET @sorder =(SELECT MAX(sorder) FROM :$t WHERE pid=?i)+1;
			SET @sorder = IF(@sorder > 0, @sorder, 1);
			INSERT INTO :$t SET ?@, sorder=@sorder", $parentId, $data);

		$id = $this->db->getInsertId();

		$insert = array();
		$parents = $this->db->fetchAll("SELECT parent_id, level FROM :$this->structure WHERE id=?i", $parentId);
		if ($parents) {
			foreach ($parents as $parent) {
				$insert[] = sprintf('(%d, %d, %d)', $id, $parent['parent_id'], $parent['level'] + 1);
			}
			$insert[] = sprintf('(%d, %d, %d)', $id, $parentId, 1);
			$this->db->query("INSERT INTO :$this->structure (id, parent_id, level) VALUES " . implode(', ', $insert));

		} else {
			$this->db->query("INSERT INTO :$this->structure (id, parent_id, level) VALUES (?i, ?i, ?i)", $id, $parentId, 1);
		}

		return $id;
	}

	public function after($nodeId, $relNodeId) {
		;
	}

	public function before($nodeId, $relNodeId) {
		;
	}

	public function changeParent($nodeId, $parentId, $sorder = NULL) {
		;
	}

	public function getSorder($nodeId) {
		;
	}

	public function hasChilds($nodeId) {
		;
	}

	public function getChildsIds($nodeId, $attachNodeId = true)
	{
		$nodes = $this->db->getColumn("
			SELECT DISTINCT id
			FROM :$this->structure
			WHERE parent_id=?i", $nodeId);

		!$nodes && $nodes = array();
		$attachNodeId && $nodes[] = $nodeId;

		return $nodes;
	}

	public function remove($nodeId)
	{
		$nodes = $this->getChildsIds($nodeId);
		$idsStr = implode(',', $nodes);

		$this->db->query("DELETE FROM :$this->table WHERE id IN (" . $idsStr . ")");
		$this->db->query("DELETE FROM :$this->structure WHERE id IN (" . $idsStr . ")");

		return $nodes;
	}
}
