<?php

abstract class BL_TreeStructure_DriverAbstract
{
	protected $options = array();

	protected $table;

	/**
	 *
	 * @var BL_Database
	 */
	protected $db;

	public function __construct(array $options)
	{
		$this->options = $options;
		if (empty($this->options['table'])) {
			throw new BL_Exception('Empty table name');
		}
		$this->db = BL_Context::instance()->db();
		$this->table = $this->options['table'];
	}


	abstract public function addNode($data, $parentId = 0, $sorder = NULL);

	abstract public function changeParent($nodeId, $parentId, $sorder = NULL);

	abstract public function before($nodeId, $relNodeId);

	abstract public function after($nodeId, $relNodeId);

	abstract public function remove($nodeId);

	abstract public function hasChilds($nodeId);

	abstract public function getSorder($nodeId);

	abstract public function getChildsIds($nodeId);

	//TODO: getParents

	//TODO: getChilds

	//TODO: getLevel
}
