<?php
/**
 * Bicycle Libraries
 *
 * Set of libraries wich can help you
 *
 * @package   Bicycle Libraries
 * @author    Konstantin.Myakshin
 * @copyright Copyright (c) 2009-2010, Brouzie, Inc.
 * @license   LGPL
 * @link      http://brouzie.com/projects/bicycle-libraries/
 * @link      http://code.google.com/p/bicycle-libraries/
 * @filesource
 */

class BL_Validator_Core extends BL_Validator_Abstract
{
	protected $messages = array(
		'notEmpty' => 'Field %field% is empty'
	);

	public function getRules()
	{
		return array('notEmpty');
	}

	public function validate($rule, $field, &$value, &$error, array $messages = array(), array $options = array())
	{
		$allowed = $this->getOption($options, 'allowed', -1, array('allowed' => array('0')));
		if (empty($value) && !in_array($value, $allowed)) {
			$error = $this->formatMessage($this->getMessage($rule, $messages), array('field' => $field));
			return false;
		}
		return true;
	}
}
